{GENERIC KEYBOARD/TIMER DRIVER
 -----------------------------
(C) 1998,99 by Arsne von Wyss - arsene@vonwyss.ch

Rev: 20000214

This source code is freeware for non-commercial use and provided AS-IS.
You are not allowed to use or spread incomplete (inclusive this header)
copies of this code. Use at your own risk. If you do not agree with these
statements, delete this source code immediately. Please contact the
author via email for questions or bug reports.}

unit Drv_Gen{eric};

interface

uses
	Objects,GUI,Canvas,Bitmaps,Events,HWIntObj;

type
	TGenericDriver=object(TDriver)
		procedure Open; virtual;
		procedure Check; virtual;
		procedure Close; virtual;
	end;
	TKeyboard=object(TInterrupt)
		Keys: array[0..127] of Boolean;
		procedure Handler; virtual;
	end;

var
	Keyboard: TKeyboard;

implementation

function TimerDrv: Longint; far; assembler;
asm {Timer tick (18.20648193359/second) -> ms}
	mov es,Seg0040
 db $66; mov ax,es:[$6C]
 db $66; sub dx,dx
 db $66,$0f,$a4,$c2,16 {shld eax,edx,16}
 db $66; shl ax,16
 db $66; sub bx,bx
	mov bx,1193
 db $66; div bx
 db $66; mov dx,ax
 db $66; shr dx,16
end;

procedure TKeyboard.Handler;
var
	Scancode: Byte;
	Pressed: Boolean;
begin
	Scancode:=Port[$60];
	inherited Handler;
	Pressed:=Scancode and $80=0;
	Scancode:=Scancode and $7F;
	if Keys[Scancode]<>Pressed then
		if Pressed then begin
			Keys[Scancode]:=True;
			Application^.Post.Keyboard(evKeyDown,#0,Scancode);
		end else begin
			Keys[Scancode]:=False;
			Application^.Post.Keyboard(evKeyUp,#0,Scancode);
		end;
end;

procedure TGenericDriver.Open;
begin
	Timer:=TimerDrv;
	Keyboard.Init(1);
end;

procedure TGenericDriver.Check;
var
	Key: Char;
	ScanCode: Byte;
begin
	asm
		mov	ah,1
		int $16
		jz @clear
		mov ah,0
		int $16
		jmp @end
	@clear:
		sub ax,ax
	@end:
		mov Key,al
		mov ScanCode,ah
	end;
	if ScanCode<>0 then
		Application^.Post.Keyboard(evKeyboard,Key,Scancode);
end;

procedure TGenericDriver.Close;
begin
	Keyboard.Done;
end;

end.
